Search code examples
python-3.xautocadcadautolisp

How to interface with AutoCAD from Python?


I've the following AutoLISP code

(defun graph ( pts sls tls )
(   (lambda ( l )
        (foreach x l (text (cdr x) (itoa (car x)) 0.0 1))
        (mapcar
           '(lambda ( a b / p q r )
                (setq p (cdr (assoc a l))
                      q (cdr (assoc b l))
                      r (angle p q)
                )
                (entmake (list '(0 . "LINE") (cons 10 p) (cons 11 q) '(62 . 8)))
                (text
                    (mapcar '(lambda ( x y ) (/ (+ x y) 2.0)) p q)
                    (rtos (distance p q) 2)
                    (if (and (< (* pi 0.5) r) (<= r (* pi 1.5))) (+ r pi) r)
                    2
                )
            )
            sls tls
        )
    )
    (mapcar 'cons (vl-sort (append sls tls) '<) pts)
)
)
(defun text ( p s a c )
    (entmake
        (list
           '(0 . "TEXT")
            (cons 10 p)
            (cons 11 p)
            (cons 50 a)
            (cons 01 s)
            (cons 62 c)
           '(40 . 2)
           '(72 . 1)
           '(73 . 2)
        )
    )
)

and the input is

(graph
   '((75 25) (115 45) (90 60) (10 5) (45 0) (45 55) (0 25))
   '(1 1 1 1 2 2 3 4 4 5 6)
   '(2 3 4 5 3 6 6 5 7 7 7)
)

The 2D geometry created from the above is exported as a dxf file from AutoCAD.

The actual input is generated in Python

pts = [(75, 25), (115, 45), (90, 60), (10, 5), (45, 0), (45, 55), (0, 25)]
sls = [1 1 1 1 2 2 3 4 4 5 6]  
tls = [2 3 4 5 3 6 6 5 7 7 7]

I would like to know how to use the python data types as input and directly interface with AutoCAD from Python, save the AutoCAD output as a dxf file.

EDIT: I've installed pyautocad in Python and did

from pyautocad import Autocad, APoint

Now I am not sure how to evaluate these AutoCAD expressions in Python. For instance, the inputs are Python tuples

Should I convert each tuple to AutoCAD point using

p = APoint(x, y)

And I am not sure how to proceed from here after generating the input data as autocad points. It's not clear to me how the commands in function

defun graph ( pts sls tls )

Any suggestions will be greatly useful


Solution

  • The interface can be established using the subprocess library of python

    """
    Created by Natasha 28/9/2020
    -This code passes inputs from python to autocad
    ref: https://stackoverflow.com/questions/48794935/batch-run-autolisp-with-python
    ref: https://forums.autodesk.com/t5/visual-lisp-autolisp-and-general/how-to-interface-with-autocad-from-python/m-p/9768816/highlight/false#M404952
    """
    import subprocess
    
    from settings import\
        GRAPH_LISP_FILE,\ # file paths
        GRAPH_SCR_FILE,\
        GRAPH_DWG_FILE,\
        GRAPH_DXF_FILE
    
    
    def write_src(graph):
        """
        Commands sent to AutoCAD aew
        :param graph:
        :return:
        """
        with open(GRAPH_SCR_FILE, 'w') as outfile:
            outfile.write("open\n" +
                          f"{GRAPH_DWG_FILE}" + "\n"
                          "(setq *LOAD_SECURITY_STATE* (getvar 'SECURELOAD))\n" +
                          '(setvar "SECURELOAD" 0)\n' +
                          rf'(load "{GRAPH_LISP_FILE}")' + "\n"
                          f"{graph}\n" +
                          '(setvar "SECURELOAD" *LOAD_SECURITY_STATE*)\n'
                          "saveas dxf 16\n" +
                          rf"{GRAPH_DXF_FILE}" +"\n"+
                          "quit"
                         )
        pass
    
    
    def iter_to_lisp_string(list_or_tuple):
        """
        Converts python datatypeS list and tuple to AutoCAD datatype
        :param list_or_tuple:
        :return:
        """
        return "(" + " ".join(map(str, list_or_tuple)) + ")"
    
    
    if __name__ == '__main__':
    
        pts_string = "'" + iter_to_lisp_string(map(iter_to_lisp_string, [(75, 25), (115, 45), (90, 60), (10, 5), (45, 0), (45, 55), (0, 25)]))
        sls_string = "'" + iter_to_lisp_string([1, 1, 1, 1, 2, 2, 3, 4, 4, 5, 6])
        tls_string = "'" + iter_to_lisp_string([2, 3, 4, 5, 3, 6, 6, 5, 7, 7, 7])
    
        graph_command_string = iter_to_lisp_string(["graph", pts_string, sls_string, tls_string])
        write_src(graph=graph_command_string)
    
        subprocess.run(["C:\\Program Files\\Autodesk\\AutoCAD 2019\\acad.exe", "/b", GRAPH_SCR_FILE])
        print("Process Finished")